////////////////////////////////////////////////////////////////
// SFXVIRS _ZN^

#include <stdio.h>
#include <ctype.h>
#include <string.h>

#include "rscnf.h"
#include "rsheap.h"
#include "rsetc.h"

////////////////////////////////
// O[oϐ

static LOADFILE *pRoot;

////////////////////////////////
// ֐`

static void CnfFlushCopy(FILE *rfp, FILE *wfp);
static void CnfFlushUpdate(FILE *rfp, FILE *wfp, LOADFILE *pFile);
static void CnfFlushAppend(FILE *wfp, LOADFILE *pFile);
static void CnfFlushAppendItem(FILE *wfp, SECTION *pSection);
static void CnfOverwriteStr(char *dst, char *src, ITEM *pItem);

static LOADFILE *CnfSeekLoadFile(char *file);
static SECTION *CnfSeekSection(LOADFILE *pFile, char *section);
static ITEM *CnfSeekItem(SECTION *pSection, char *item);
static LOADFILE *CnfAddLoadFile(char *file);
static SECTION *CnfAddSection(LOADFILE *pFile, char *section);
static ITEM *CnfAddItem(SECTION *pSection, char *item, char *str);

static char *fgetsEx(char *s, int n, FILE *stream);
static int fputsEx(const char *s, FILE *stream);

////////////////////////////////
// 

void CnfInit()
{
	pRoot = (LOADFILE *)NULL;
}

////////////////////////////////
// n

void CnfTerm()
{
	LOADFILE *pFile = pRoot;

	while (pFile) {
		CnfFlush(pFile);
		pFile = pFile->next;
	}
}

////////////////////////////////
// ǂݍ

BOOL CnfLoad(char *file)
{
	return CnfLoad2(file, file);
}

BOOL CnfLoad2(char *file, char *append)
{
	FILE     *fp       = (FILE *)NULL;
	LOADFILE *pFile    = (LOADFILE *)NULL;
	SECTION  *pSection = (SECTION *)NULL;
	ITEM     *pItem    = (ITEM *)NULL;
	unsigned char *pName, *pStr, *p1, *p2;
	int      nLine;
	unsigned char buf[256];

	if (file   == NULL) return FALSE;
	if (append == NULL) return FALSE;

	// t@CJ
	fp = fopen(file, "r");
	if (fp == NULL) {
		// t@CI[vG[
		return FALSE;
	}

	// LOADFILE\̂̓o^
	pFile = CnfSeekLoadFile(append);
	if (pFile == NULL) {
		pFile = CnfAddLoadFile(append);
		if (pFile == NULL) {
			// s
			return FALSE;
		}
	}

	nLine = 0;
	for(;;) {
		// sǂݍ
		p1 = (unsigned char *)fgets((char *)buf, 256, fp);
		if (p1 == NULL) break;
		p1 = buf;
		nLine++;

		// 󔒂̓ǂݔ΂
		while (isspace(*p1)) p1++;

		// s̎ʔ
		if (*p1 == '\0') {
			// s͉Ȃ
			;
		} else if (*p1 == '#') {
			// Rgs͉Ȃ
			;
		} else if (*p1 == '[') {
			// ZNV
			p1++;

			// ZNV̐؂肾
			pName = p1;
			while (*p1 && (*p1 != ']')) p1++;
			if (*p1 == '\0') {
				// ZNV']'Ȃ
				return FALSE;
			}
			*p1 = '\0';

			// ZNV̓o^
			pSection = CnfSeekSection(pFile, (char *)pName);
			if (pSection == NULL) {
				pSection = CnfAddSection(pFile, (char *)pName);
				if (pSection == NULL) {
					// s
					return FALSE;
				}
			}
		} else {
			// ڒ`s

			// ږ̐؂肾
			pName = p1;
			while (*p1 && !isspace(*p1) && (*p1 != '=')) p1++;
			p2 = p1;

			// 󔒂̓ǂݔ΂
			while (isspace(*p1)) p1++;

			// ؂蕶̃`FbN
			if (*p1 == '=') {
				p1++;

				// 󔒂̓ǂݔ΂
				while (isspace(*p1)) p1++;

				// ̓ǂݍ
				if (*p1 == '"') {
					p1++;
					pStr = p1;
					while (*p1 && (*p1 != '"')) p1++;
				} else if (*p1 && (*p1 != '#')) {
					pStr = p1;
					while (*p1 && (*p1 != '#')) p1++;
					p1--;
					while (isspace(*p1)) p1--;
					p1++;
				} else {
					pStr = (unsigned char *)"";
				}
				*p1 = '\0';
				*p2 = '\0';

				// ڂ̓o^
				pItem = CnfSeekItem(pSection, (char *)pName);
				if (pItem == NULL) {
					pItem = CnfAddItem(pSection, (char *)pName, (char *)pStr);
					if (pItem == NULL) {
						// s
						return FALSE;
					}
				}
			} else {
				// SyntaxG[
			}
		}
	}

	return TRUE;
}

char *CnfGetStr(char *file, char *section, char *item)
{
	LOADFILE *pFile;
	SECTION  *pSection;
	ITEM     *pItem;

	// t@Č
	pFile = CnfSeekLoadFile(file);
	if (pFile == NULL) return NULL;

	// ZNV̌
	pSection = CnfSeekSection(pFile, section);
	if (pSection == NULL) return NULL;

	// ACě
	pItem = CnfSeekItem(pSection, item);
	if (pItem == NULL) return NULL;

	return pItem->str;
}

int CnfGetInt(char *file, char *section, char *item)
{
	char *p;
	int value = 0;
	short bMinus = FALSE;

	// 擾
	p = CnfGetStr(file, section, item);
	if (p == NULL) return 0;

	// 𐔒lɕϊ

	while (isspace(*p)) p++;
	if (*p == '-') {
		bMinus = TRUE;
		p++;
	}

	value = 0;
	if (*p == '0') {
		p++;
		if ((*p == 'x') || (*p == 'X')) {
			// PUi
			for (;;) {
				if (('0' <= *p) && (*p <= '9')) {
					value = value * 16 + (*p - '0');
				} else if (('A' <= *p) && (*p <= 'F')) {
					value = value * 16 + (*p - 'A' + 10);
				} else if (('a' <= *p) && (*p <= 'f')) {
					value = value * 16 + (*p - 'a' + 10);
				} else {
					break;
				}
				p++;
			}
		} else if ((*p == 'b') || (*p == 'B')) {
			// Qi
			while (('0' <= *p) && (*p <= '1')) {
				value = value * 2 + (*p - '0');
				p++;
			}
		} else {
			// Wi
			while (('0' <= *p) && (*p <= '7')) {
				value = value * 8 + (*p - '0');
				p++;
			}
		}
	} else {
		// POi
		while (('0' <= *p) && (*p <= '9')) {
			value = value * 10 + (*p - '0');
			p++;
		}
	}

	if (bMinus) value = -value;

	return value;
}

ITEM *CnfFindItem(char *file, char *section)
{
	LOADFILE *pFile;
	SECTION  *pSection;

	// t@Č̖
	pFile = CnfSeekLoadFile(file);
	if (pFile == NULL) return NULL;

	// ZNV̌
	pSection = CnfSeekSection(pFile, section);
	if (pSection == NULL) return NULL;

	return pSection->item;
}

////////////////////////////////
// 

void CnfSave(char *file)
{
	// w肵t@CXV

	CnfFlush(CnfSeekLoadFile(file));
}

void CnfSetStr(char *file, char *section, char *item, char *str)
{
	LOADFILE *pFile;
	SECTION  *pSection;
	ITEM     *pItem;

	// t@Čǉ
	pFile = CnfSeekLoadFile(file);
	if (pFile == NULL) {
		pFile = CnfAddLoadFile(file);
		if (pFile == NULL) goto ErrMemory;
	}
	pFile->dirty = TRUE;

	// ZNV̌ǉ
	pSection = CnfSeekSection(pFile, section);
	if (pSection == NULL) {
		pSection = CnfAddSection(pFile, section);
		if (pSection == NULL) goto ErrMemory;
	}
	pSection->dirty = TRUE;

	// ACěǉ
	pItem = CnfSeekItem(pSection, item);
	if (pItem == NULL) {
		if (str != NULL) {
			pItem = CnfAddItem(pSection, item, str);
			if (pItem == NULL) goto ErrMemory;
		}
	} else {
		if (str != NULL) {
			if ((pItem->str == NULL) ||
			    (strlen(str) > strlen(pItem->str))) {
				pItem->str = HeapString(str);
			} else {
				strcpy(pItem->str, str);
			}
		} else {
			pItem->str = NULL;
		}
	}
	pItem->dirty = TRUE;

	return;

ErrMemory:
	fputs("Error - rscnf: słB\n", stdout);
	return;
}

void CnfSetInt(char *file, char *section, char *item, int value)
{
	char buf[16];

	sprintf(buf, "%d", value);
	CnfSetStr(file, section, item, buf);
}

void CnfFlush(LOADFILE *pFile)
{
	FILE *fp1 = NULL;
	FILE *fp2 = NULL;
	char TempName[256];

	if (pFile == NULL) return;
	if (pFile->dirty == FALSE) return;

	// e|t@C̖O쐬
	if (tmpnam(TempName) == NULL) goto ErrTemp;

	// t@C̃`FbN
	fp1 = fopen(pFile->name, "rb");
	if (fp1) {
		// ̃t@Cɒǉ

		// e|t@CJ
		fp2 = fopen(TempName, "wb");
		if (fp2 == NULL) goto ErrTemp;

		// e|t@Cɕʂ
		CnfFlushCopy(fp1, fp2);

		// t@C
		fclose(fp1);
		fclose(fp2);
		fp1 = NULL;
		fp2 = NULL;

		// t@CJ
		fp1 = fopen(pFile->name, "wb");
		if (fp1 == NULL) goto ErrOpen;

		fp2 = fopen(TempName, "rb");
		if (fp2 == NULL) goto ErrTemp;

		// ڂ㏑
		CnfFlushUpdate(fp2, fp1, pFile);

		// ڂǉ
		CnfFlushAppend(fp1, pFile);

		// t@C
		fclose(fp1);
		fclose(fp2);

		// e|t@C폜
		remove(TempName);
	} else {
		// t@CJ
		fp1 = fopen(pFile->name, "wb");
		if (fp1 == NULL) goto ErrOpen;

		// ڂǉ
		CnfFlushAppend(fp1, pFile);

		// t@C
		fclose(fp1);
	}
	pFile->dirty = FALSE;

	return;

ErrOpen:
	fputs("Error - rscnf: t@CJƂo܂B\n", stdout);
	goto Err;
ErrTemp:
	fputs("Error - rscnf: e|t@CJƂo܂B\n", stdout);
	goto Err;
Err:
	if (fp1) fclose(fp1);
	if (fp2) fclose(fp2);
	return;
}

static void CnfFlushCopy(FILE *rfp, FILE *wfp)
{
	char buf[256];

	// t@CRs[
	while (!feof(rfp)) {
		fgetsEx(buf, 256, rfp);
		fputsEx(buf, wfp);
	}
}

static void CnfFlushUpdate(FILE *rfp, FILE *wfp, LOADFILE *pFile)
{
	char    src[256];
	char    dst[256];
	SECTION *pSection = NULL;
	ITEM    *pItem = NULL;
	BOOL    bDelete;
	char    *p1, *p2;

	// ύXڂ㏑

	// t@C𕡎ʂȂAڂ
	for (;;) {

		// Psǂݍ
		p1 = fgetsEx(src, 256, rfp);
		if (p1 == NULL) break;
		p1 = src;

		// 󔒂̓ǂݔ΂
		while (isspace(*p1)) p1++;

		// s̎ʔ
		bDelete = FALSE;
		if (*p1 == '\0') {
			// s
			int n, ofs;

			// s̕
			strcpy(dst, src);

			// ItZbgʒuۑ
			ofs = ftell(rfp);

			// s𐔂
			n = 0;
			for (;;) {
				p1 = fgetsEx(src, 256, rfp);
				if (p1 == NULL) break;
				p1 = src;

				while (isspace(*p1)) p1++;
				if (*p1) break;

				n++;
			}

			// VKڂ̒ǉ
			if (p1 == NULL) p1 = "[";
			if (*p1 == '[') {
				CnfFlushAppendItem(wfp, pSection);
			}

			// ItZbgʒu߂
			fseek(rfp, ofs, SEEK_SET);

			// s̏o
			fputsEx(dst, wfp);
			while (n > 0) {
				p1 = fgetsEx(dst, 256, rfp);
				if (p1 == NULL) break;
				fputs(dst, wfp);
				n--;
			}

			bDelete = TRUE;

		} else if (*p1 == '#') {
			// Rgs

			// s̕
			strcpy(dst, src);

		} else if (*p1 == '[') {
			// ZNV

			// VKڂ̒ǉ
			CnfFlushAppendItem(wfp, pSection);

			// ZNV̎擾
			p1++;
			p2 = dst;
			while (*p1 && (*p1 != ']')) *(p2++) = *(p1++);
			*p2 = '\0';

			if (*p1) {
				// ZNV̎擾
				pSection = CnfSeekSection(pFile, dst);
			} else {
				sprintf(dst,
					"Error - rscnf: ZNVɊԈႢ܂B\n"
					"%s\n", src);
				fputs(dst, stdout);
			}

			// s̕
			strcpy(dst, src);

		} else {
			// 

			// ږ̎擾
			p2 = dst;
			while (*p1 && (!isspace(*p1)) && (*p1 != '=')) *(p2++) = *(p1++);
			*p2 = '\0';

			// ڍs̃`FbN
			while (isspace(*p1)) p1++;
			if (*p1 == '=') {
				// ڍs

				// ڂ̎擾
				pItem = CnfSeekItem(pSection, dst);
				if (pItem && pItem->dirty) {
					if (pItem->str) {
						// ㏑
						CnfOverwriteStr(dst, src, pItem);
					} else {
						// 폜
						bDelete = TRUE;
					}
					pItem->dirty = FALSE;
				} else {
					strcpy(dst, src);
				}
			} else {
				// ڍsȊO
				strcpy(dst, src);
			}
		}

		// s
		if (bDelete == FALSE) fputsEx(dst, wfp);
	}

	// VKڂ̒ǉ
	CnfFlushAppendItem(wfp, pSection);
}

static void CnfFlushAppend(FILE *wfp, LOADFILE *pFile)
{
	SECTION *pSection;
	char    buf[256];

	if (pFile == NULL) return;
	if (pFile->dirty == FALSE) return;

	// VKZNVǉ
	pSection = pFile->section;
	while (pSection) {
		if (pSection->dirty) {
			sprintf(buf, "[%s]\n", pSection->name);
			fputsEx(buf, wfp);

			CnfFlushAppendItem(wfp, pSection);

			fputsEx("\n", wfp);
		}
		pSection = pSection->next;
	}
	pFile->dirty = FALSE;
}

static void CnfFlushAppendItem(FILE *wfp, SECTION *pSection)
{
	ITEM    *pItem;
	char    buf[256];

	if (pSection == NULL) return;
	if (pSection->dirty == FALSE) return;

	// VKڂǉ
	pItem = pSection->item;
	while (pItem) {
		if ((pItem->dirty) && (pItem->str)) {
			sprintf(buf, "%s = %s\n", pItem->name, pItem->str);
			fputsEx(buf, wfp);

			pItem->dirty = FALSE;
		}
		pItem = pItem->next;
	}
	pSection->dirty = FALSE;
}

static void CnfOverwriteStr(char *dst, char *src, ITEM *pItem)
{
	char *p;
	char *pEqual;

	// ږƋ󔒂𕡎
	while (*src && (*src != '=')) *(dst++) = *(src++);
	pEqual = src;

	// '='𕡎
	*(dst++) = *(src++);

	// 󔒂𕡎
	*dst = '\0';
	p = dst;
	while (isspace(*src)) *(dst++) = *(src++);
	if ((*src == '\0') || (*src == '#')) {
		dst = p;
		if ((*dst == ' ') || (*dst == '\t')) dst++;
	}

	// 񕔕̓ǂݔ΂
	if (*src == '"') {
		while (*src && (*src != '"')) src++;
	} else {
		while (*src && (*src != '#')) src++;
		src--;
		while (isspace(*src)) src--;
		if (src == pEqual) src++;
		src++;
	}

	// 񕔕̕
	p = pItem->str;
	while (*p) *(dst++) = *(p++);

	// 󔒂ƃRg̕
	while (*src) *(dst++) = *(src++);

	*dst = '\0';
}

////////////////////////////////
// Xg

static LOADFILE *CnfSeekLoadFile(char *file)
{
	LOADFILE *pFile = pRoot;

	if (file == NULL) return NULL;

	// P@
	while (pFile) {
		if (stricmp(pFile->name, file) == 0) return pFile;
		pFile = pFile->next;
	}
	return NULL;
}

static SECTION *CnfSeekSection(LOADFILE *pFile, char *section)
{
	SECTION *pSection = NULL;

	if (pFile == NULL) return NULL;
	if (section == NULL) return NULL;

	pSection = pFile->section;

	// P@
	while (pSection) {
		if (stricmp(pSection->name, section) == 0) return pSection;
		pSection = pSection->next;
	}
	return NULL;
}

static ITEM *CnfSeekItem(SECTION *pSection, char *item)
{
	ITEM *pItem = NULL;

	if (pSection == NULL) return NULL;
	if (item == NULL) return NULL;

	pItem = pSection->item;

	// P@
	while (pItem) {
		if (stricmp(pItem->name, item) == 0) return pItem;
		pItem = pItem->next;
	}
	return NULL;
}

////////////////////////////////
// Xgǉ

static LOADFILE *CnfAddLoadFile(char *file)
{
	LOADFILE *pFile = NULL;

	if (file == NULL) return NULL;

	// ̊m
	pFile = (LOADFILE *)HeapAlloc(sizeof(LOADFILE));
	if (pFile == NULL) return NULL;

	// 
	pFile->next    = NULL;
	pFile->name    = HeapString(file);
	pFile->section = NULL;
	pFile->dirty   = FALSE;
	if (pFile->name == NULL) return NULL;

	// Xgւ̒ǉ
	if (pRoot) {
		LOADFILE *pSeek = pRoot;

		while (pSeek->next) pSeek = pSeek->next;
		pSeek->next = pFile;
	} else {
		pRoot = pFile;
	}

	return pFile;
}

static SECTION *CnfAddSection(LOADFILE *pFile, char *section)
{
	SECTION *pSection = NULL;

	if (pFile == NULL) return NULL;
	if (section == NULL) return NULL;

	// ̊m
	pSection = (SECTION *)HeapAlloc(sizeof(SECTION));
	if (pSection == NULL) return NULL;

	// 
	pSection->next  = NULL;
	pSection->name  = HeapString(section);
	pSection->item  = NULL;
	pSection->dirty = FALSE;
	if (pSection->name == NULL) return NULL;

	// Xgւ̒ǉ
	if (pFile->section) {
		SECTION *pSeek = pFile->section;

		while (pSeek->next) pSeek = pSeek->next;
		pSeek->next = pSection;
	} else {
		pFile->section = pSection;
	}

	return pSection;
}

static ITEM *CnfAddItem(SECTION *pSection, char *item, char *str)
{
	ITEM *pItem = NULL;

	if (pSection == NULL) return NULL;
	if (item == NULL) return NULL;
	if (str == NULL) return NULL;

	// ̊m
	pItem = (ITEM *)HeapAlloc(sizeof(ITEM));
	if (pItem == NULL) return NULL;

	// 
	pItem->next  = NULL;
	pItem->name  = HeapString(item);
	pItem->str   = HeapString(str);
	pItem->dirty = FALSE;
	if (pItem->name == NULL) return NULL;
	if (pItem->str  == NULL) return NULL;

	// Xgւ̒ǉ
	if (pSection->item) {
		ITEM *pSeek = pSection->item;

		while (pSeek->next) pSeek = pSeek->next;
		pSeek->next = pItem;
	} else {
		pSection->item = pItem;
	}

	return pItem;
}

////////////////////////////////
// o

static char *fgetsEx(char *s, int n, FILE *stream)
{
	char *p;

	p = fgets(s, n, stream);

	if (p) {
		char *src = p;
		char *dst = p;
		while (*src) {
			     if ((*src == 0x0d) && (*(src+1) == 0x0a)) src++;
			else if ((*src == 0x1a) && (*(src+1) == 0x00)) src++;
			*(dst++) = *(src++);
		}
		*(dst++) = *(src++);
	}

	return p;
}

static int fputsEx(const char *s, FILE *stream)
{
	char buf[256+2];
	char *p;
	int  n;

	while (*s) {
		p = buf;
		n = 256;
		while (*s && (n > 0)) {
			if (*s == 0x0a) {
				*(p++) = 0x0d;
				n--;
			}
			*(p++) = *(s++);
			n--;
		}
		*p = '\0';
		fputs(buf, stream);
	}

	return 0;
}
