////////////////////////////////////////////////////////////////
// SFXVIRS _ZN^

#include "rsheap.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static char *pHeapBuf;
static char *pHeapFree;
static int  nFreeSize;

static int  nHeapSize;  // Debug

////////////////////////////////////////////////////////////////
// HeapInit  q[v̈mۂ

BOOL HeapInit(int size) {
	int i;

	nHeapSize = size;  // Debug

	// ̊m
	pHeapBuf = (char *)malloc(size);
	if (pHeapBuf == NULL) return FALSE;

	// ̏
	for (i = 0; i < size; i++) pHeapBuf[i] = 0;

	pHeapFree = pHeapBuf;
	nFreeSize = size;

	return TRUE;
}


////////////////////////////////////////////////////////////////
// HeapTerm  q[v̈

void HeapTerm() {
/*
	// Debug
	int n, m, x, y;
	n = nHeapSize-nFreeSize;
	x = n * 100 / nHeapSize;
	m = n * 100 % nHeapSize;
	y = m * 100 / nHeapSize;
	printf("Memory : Used/Total %d/%d(%d.%02d%%)\n", n, nHeapSize, x, y);
*/
	// ̉
	if (pHeapBuf) free(pHeapBuf);
}


////////////////////////////////////////////////////////////////
//  HeapAlloc  q[v̈悩wTCỸmۂ

void *HeapAlloc(int size) {
	char *ptr = (char *)NULL;

	// O[hoE_ɂ悤ɒ
	size = (size + 3) & 0xfffffffc;

	// q[v̈؂o
	if (size <= nFreeSize) {
		ptr        = pHeapFree;
		pHeapFree += size;
		nFreeSize -= size;
	}

	return (void*)ptr;
}

////////////////////////////////////////////////////////////////
// HeapString  q[v̈悩當񕪂̗̈mہAʂ

char *HeapString(char *str) {
	char *ptr = (char *)NULL;
	int  len;

	// ̊m
	len = strlen(str) + 1;
	ptr = (char *)HeapAlloc(len);

	// ̕
	if (ptr) strcpy(ptr, str);

	return ptr;
}
